----------------------------------------
--|   PSPGuess v1.0                  |--
--|   By: Roberto Villarreal         |--
--|   PSPByRoberto@gmail.com         |--
----------------------------------------

-- Activate USB Mode For Debugging

System.usbDiskModeActivate()

-- Functions

-- printData() - Prints All Data To The Screen While Guessing

function printData()
	screen:clear()
	screen:blit(0, 0, gamebg, false)
	screen:print(105, 85, num, color5)
	screen:print(105, 115,lowest .. " < x < " .. highest, color6)
	screen:print(30, 225, "Pad Up:         Add 1   | Pad Down:      Subtract 1", color5)
	screen:print(30, 235, "Pad Right:      Add 10  | Pad Left:      Subtract 10", color5)
	screen:print(30, 245, "Shoulder Right: Add 100 | Shoulder Left: Subtract 100", color5)
	screen:print(25, 15, "PSPGuess | Roberto Villarreal | PSPbyRoberto@gmail.com", color4)
	screen:print(25, 15, "         |                    |                       ", color3)
	screen.flip()
end

--printDataGuessed() - Prints Data After Submitting A Guess 

function printDataGuessed(case)
	screen:clear()
	screen:blit(0, 0, gamebg, false)
	screen:print(105, 85, num, color5)
	screen:print(30, 225, "Pad Up:         Add 1   | Pad Down:      Subtract 1", color5)
	screen:print(30, 235, "Pad Right:      Add 10  | Pad Left:      Subtract 10", color5)
	screen:print(30, 245, "Shoulder Right: Add 100 | Shoulder Left: Subtract 100", color5)
	screen:print(25, 15, "PSPGuess | Roberto Villarreal | PSPbyRoberto@gmail.com", color4)
	screen:print(25, 15, "         |                    |                       ", color3)

	if case == 1 then
		screen:print(105, 115, "Higher!", color3)
	elseif case == 2 then
		screen:print(105, 115, "Lower!", color3)
	elseif case == 3 then
		screen:print(105, 115, "Correct!", color2)
	end

	screen.flip()
end

-- Set Colors and Background

color1 = Color.new(180, 180, 180) -- Grey
color2 = Color.new(0, 255, 0)     -- Green
color3 = Color.new(255, 0, 0)     -- Red
color4 = Color.new(120, 120, 120)   -- Dark Grey
color5 = Color.new(0, 0, 0)       -- Black
color6 = Color.new(0, 0, 255)	  -- Blue

-- Load Background Images

gamebg = Image.load("/images/gamebg.png")
mainbg = Image.load("/images/mainbg.png")

-----------------------------------------------------------
-- Start Main Script
-----------------------------------------------------------

while true do

	-- Set Controls Variable, Initialize Loop Controllers, And Number Variables
	
	pad = Controls.read()

	menu_exit = false
	game_exit = false
	num = 0
	lowest = 0
	highest = 0
	answer = 0

	if pad:start() then
		break
	end

	-- Start Menu Loop, Controlled By boolean menu_exit

	while not menu_exit do
		pad = Controls.read()

		-- Display Menu, Printed Twice To Simulte Different Colored Outlining

		screen:clear()
		screen:blit(0, 0, mainbg, false)
		screen:print(25, 15, "PSPGuess | Roberto Villarreal | PSPbyRoberto@gmail.com", color4)
		screen:print(25, 15, "         |                    |                       ", color3)
		screen:print(35, 60, "*-------------------------------------------------*", color5)
		screen:print(35, 70, "|               Choose A Game Type                |", color3)
		screen:print(35, 80, "*-------------------------------------------------*", color5)
		screen:print(35, 90, "| Cross:     Guess Between 1 and 10              |", color4)
		screen:print(35, 100, "| Square:    Guess Between 1 and 100              |", color4)
		screen:print(35, 110, "| Triangle:  Guess Between 1 and 1000             |", color4)
		screen:print(35, 120, "| Circle:    Guess Between 1 and 10000            |", color4)
		screen:print(35, 130, "| Pad Down:  Guess Between -10 and 10             |", color4)
		screen:print(35, 140, "| Pad Left:  Guess Between -100 and 100           |", color4)
		screen:print(35, 150, "| Pad Up:    Guess Between -1000 and 1000         |", color4)
		screen:print(35, 160, "| Pad Right: Guess Between -10000 and 10000       |", color4)
		screen:print(35, 170, "*-------------------------------------------------*", color5)
		-- Outlining
		screen:print(35, 60, "*-------------------------------------------------*", color5)
		screen:print(35, 70, "|                                                 |", color5)
		screen:print(35, 80, "*-------------------------------------------------*", color5)
		screen:print(35, 90, "|                                                 |", color5)
		screen:print(35, 100, "|                                                 |", color5)
		screen:print(35, 110, "|                                                 |", color5)
		screen:print(35, 120, "|                                                 |", color5)
		screen:print(35, 130, "|                                                 |", color5)
		screen:print(35, 140, "|                                                 |", color5)
		screen:print(35, 150, "|                                                 |", color5)
		screen:print(35, 160, "|                                                 |", color5)
		screen:print(35, 170, "*-------------------------------------------------*", color5)
		screen.flip()

		-- Process Choice

		if pad:cross() then
			lowest = 1
			highest = 10
			menu_exit = true
		elseif pad:square() then
			lowest = 1
			highest = 100
			menu_exit = true
		elseif pad:triangle() then
			lowest = 1
			highest = 1000
			menu_exit = true
		elseif pad:circle() then
			lowest = 1
			highest = 1000
			menu_exit = true
		elseif pad:down() then
			lowest = -10
			highest = 10
			menu_exit = true
		elseif pad:left() then
			lowest = -100
			highest = 100
			menu_exit = true
		elseif pad:up() then
			lowest = -1000
			highest = 1000
			menu_exit = true
		elseif pad:right() then
			lowest = -10000
			highest = 10000
			menu_exit = true
		elseif pad:start() then
			game_exit = true
			break
		else
			menu_exit = false
		end
	end

	-- Seed And Generate Random Number Between lowest And highest

	math.randomseed(os.time())
	answer = math.random(lowest, highest)

	screen.waitVblankStart(20)	-- Prevents Higher! / Lower!
					-- From Being Displayed When
					-- Choosing cross From Menu

	-- Start Game Loop, Controlled By boolean game_exit

	while not game_exit do
		pad = Controls.read()

		printData()

		if pad:start() then
			break
		end

		-- Manipulate Numbers
		-- Control Numbers Based On lowest And highest

		if pad:up() then
			if num + 1 > highest then
				num = highest
			else
        			num = num + 1
			end

			printData()
			screen.waitVblankStart(15)
		elseif pad:down() then
			if num - 1 < lowest then
				num = lowest
			else
				num = num - 1
			end

			printData()
			screen.waitVblankStart(15)
		elseif pad:right() then
			if num + 10 > highest then
				num = highest
			else
				num = num + 10
			end

			printData()
			screen.waitVblankStart(10)
		elseif pad:left() then
			if num - 10 < lowest then
				num = lowest
			else
				num = num - 10
			end

			printData()
			screen.waitVblankStart(10)
		elseif pad:r() then
			if num + 100 > highest then
				num = highest
			else
				num = num + 100
			end

			printData()
			screen.waitVblankStart(10)
		elseif pad:l() then
			if num - 100 < lowest then
				num = lowest
			else
				num = num - 100
			end

			printData()
			screen.waitVblankStart(10)
		elseif pad:cross() then
			if num < answer then
				printDataGuessed(1)
				screen.waitVblankStart(30)
			elseif num > answer then
				printDataGuessed(2)
				screen.waitVblankStart(30)
			elseif num == answer then
				printDataGuessed(3)
				screen.waitVblankStart(120)
				game_exit = true
			end
		end
	end
end	-- It's All Over! *Cries*